
package com.kingdee.eas.custom.dormitorysystem.application.web;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.operamasks.faces.annotation.Inject;
import org.operamasks.faces.annotation.ManagedBean;
import org.operamasks.faces.annotation.ManagedBeanScope;
import com.kingdee.bos.metadata.IMetaDataPK;
import com.kingdee.bos.metadata.MetaDataPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.waf.annotation.IBOSBizCtrl;
import com.kingdee.bos.waf.util.OperateState;
import com.kingdee.bos.waf.winlet.edit.EditBean;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.framework.ICoreBase;
import org.operamasks.faces.annotation.Accessible;
import org.operamasks.faces.component.form.impl.*;
import com.kingdee.bos.waf.action.AbstractWebAction;
import javax.faces.event.AbortProcessingException;
import javax.faces.context.FacesContext;
import org.operamasks.faces.component.action.ActionEvent;
import org.operamasks.faces.annotation.Action;
import com.kingdee.bos.waf.winlet.BaseBean;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;

import com.kingdee.eas.custom.dormitorysystem.application.IRoomChangeApplication;
import com.kingdee.eas.custom.dormitorysystem.application.RoomChangeApplicationInfo;
import com.kingdee.eas.custom.dormitorysystem.application.RoomChangeApplicationEntryInfo;
import com.kingdee.eas.custom.dormitorysystem.application.RoomChangeApplicationEntryCollection;

public abstract class AbstractRoomChangeApplicationEditUIBean extends com.kingdee.bos.waf.winlet.edit.EditBean {

	@IBOSBizCtrl
	protected com.kingdee.eas.custom.dormitorysystem.application.IRoomChangeApplication service;

	@Inject("custom.dormitorysystem.application.RoomChangeApplicationEntryBean")
	protected RoomChangeApplicationEntryBean roomChangeApplicationEntryBean;
	public AbstractRoomChangeApplicationEditUIBean() {
		super();
	}

	
	
	@Override
	public void createNewModel() {
		model = new RoomChangeApplicationInfo();
	}

	@Override
	public void pageOnload() {
		super.pageOnload();
		
		RoomChangeApplicationEntryCollection entryCol_0 = ((RoomChangeApplicationInfo) model).getEntrys();

		List<CoreBaseInfo> listModel_0 = new LinkedList<CoreBaseInfo>();
		if (entryCol_0 != null)
		{
			for (int i = 0, n = entryCol_0.size(); i < n; i++) {
				listModel_0.add(entryCol_0.get(i));
			}
	
			roomChangeApplicationEntryBean.setListModel(listModel_0);
		}

		
	}

	@Override
	public void saveModel() {
		updateModel();
		super.saveModel();
	}

	@Override
	public void submitModel() {
		updateModel();
		super.submitModel();
	}


	protected void updateModel() {
		
		if (roomChangeApplicationEntryBean == null)
			roomChangeApplicationEntryBean = (RoomChangeApplicationEntryBean) com.kingdee.bos.waf.util.BeanUtil
					.getBean("custom.dormitorysystem.application.RoomChangeApplicationEntryBean");

		roomChangeApplicationEntryBean.updataModel();
		List<CoreBaseInfo> entryModel_0 = roomChangeApplicationEntryBean.getListModel();
		((RoomChangeApplicationInfo) model).getEntrys().clear();
		if (entryModel_0 != null) {
			for (CoreBaseInfo entryInfo : entryModel_0) {
				((RoomChangeApplicationInfo) model).getEntrys().add(
						(RoomChangeApplicationEntryInfo) entryInfo);
			}
		}

	}
	
	
	//entry
	public void roomChangeApplicationEntryBean_apendRow(){
		roomChangeApplicationEntryBean.appendRow();
	}
	public void roomChangeApplicationEntryBean_removeRow(){
		roomChangeApplicationEntryBean.removeRow();
	}
		

	@Override
	protected ICoreBase getBizInterface() {
		return service;
	}
	
	@Override
	public IMetaDataPK getMetaDataPK() {
		return new MetaDataPK("com.kingdee.eas.custom.dormitorysystem.application.web.RoomChangeApplicationEditUI");
	}
	
	@Override
	protected String getEntryPKName() {
	
		return "entrys.id";
	
	}

	@Override
	public SelectorItemCollection getSelectors() {
		SelectorItemCollection sic = super.getSelectors();
        sic.add(new SelectorItemInfo("number"));
        sic.add(new SelectorItemInfo("bizDate"));
        sic.add(new SelectorItemInfo("handler.*"));
        sic.add(new SelectorItemInfo("description"));
        sic.add(new SelectorItemInfo("auditor.*"));
        sic.add(new SelectorItemInfo("entrys.id"));
        sic.add(new SelectorItemInfo("entrys.person.*"));
        sic.add(new SelectorItemInfo("entrys.adminOrg.*"));
        sic.add(new SelectorItemInfo("entrys.position.*"));
        sic.add(new SelectorItemInfo("entrys.currentRoom.*"));
        sic.add(new SelectorItemInfo("entrys.checkInDate"));
        sic.add(new SelectorItemInfo("entrys.adjustRoom.*"));
        sic.add(new SelectorItemInfo("entrys.adjustmentDate"));
        sic.add(new SelectorItemInfo("entrys.notes"));
        sic.add(new SelectorItemInfo("entrys.checkoutDate"));
        sic.add(new SelectorItemInfo("entrys.oldOccupants.*"));
        sic.add(new SelectorItemInfo("entrys.occupants.*"));
        sic.add(new SelectorItemInfo("entrys.oldCheckoutDate"));
        sic.add(new SelectorItemInfo("managementNotes"));
	
		return sic;
	}			
    	protected String getTDTemplateName() {
	    	return "/bim/custom/dormitorysystem/application/RoomChangeApplication";
		}
	    protected com.kingdee.bos.metadata.IMetaDataPK getTDQueryPK() {
	    	return new com.kingdee.bos.metadata.MetaDataPK("com.kingdee.eas.custom.dormitorysystem.application.app.RoomChangeApplicationQuery");
	    }

}
